#include<vector>
#include<iostream>
#include<fstream>
#include<sstream>


#define matrix double**

using std::vector;
using std::pair;

class PredList {
private:
	int* list;
	int N;
	int curr;



bool isPredD(matrix X, int p, int i, int j) {
	bool res= true;
	for(int k=0; k<p; k++) {
		res=res & (X[k][i]<=X[k][j]);
	}
	return(res);

}
public:
	PredList(int N){
		this->N=N;
		list=new int[N];
		curr=0;
	}
	void clean(){
		for(int i=0; i<N; i++) list[i]=-1;
		curr=0;
	}
	void addElem(int k){
		list[curr]=k;
		curr++;
	}

	bool find(int k, matrix X, int p) {
		for(int i=0;i<curr;i++) if (isPredD(X,p,k,list[i])) return(true);
		return(false);
	}
	int getLength(){
		return curr;
	}
	~PredList(){
		delete [] list;
	}

};



bool isPredD(matrix X, int p, int i, int j) {
	bool res= true;
	for(int k=0; k<p; k++) {
		res=res & (X[k][i]<=X[k][j]);
	}
	return(res);

}

int compare0 (const void * a, const void * b){
		pair<int,int> a1= *(pair<int,int>*)a;
		pair<int,int> b1= *(pair<int,int>*)b;
		return(a1.second<b1.second?(-1):(a1.second>b1.second)?1:(a1.first<b1.first?-1:1));

	}
void sortAdj(vector<pair<int, int>>* radj,  vector<int>& order , int N, vector<int>& neworder, vector<int>&revorder){
		pair<int,int>* ids= new pair<int,int>[N];
		
		for(int i=0; i<N; i++){
			ids[i].first=i;
			ids[i].second=order[i];
		} 
		if (N>1) qsort(ids,N,sizeof(pair<int,int>),compare0);

		for (int i=0; i<N; i++){
			neworder[i]=ids[i].first;
			revorder[neworder[i]]=i;
		}
		for(int i=0; i<radj->size(); i++){
			(*radj)[i].first=revorder[(*radj)[i].first];
			(*radj)[i].second=revorder[(*radj)[i].second];
		}
		delete [] ids;
}



/* Function computes adjacency matrix for a matrix X' which is obtained from the matrix X of the size [N x p] by sorting x
 values with respect to the number of their predecessors. Function returns also:
 	- ord: the vector which maps indices of X into X', i.e. if X[i,]=X'[j,] then ord[i]=j
	- Ynew: Y values reordered in accordance with ord.

	Code written by O. Sysoev

     Reference: O. Burdakov, O. Sysoev, A. Grimvall and M. Hussian. 
                "An O(n2) algorithm for isotonic regression."
                 In: G. Di Pillo and M. Roma (Eds) Large-Scale Nonlinear Optimization.
                 Series: Nonconvex Optimization and Its Applications,
                 Springer-Verlag, (2006) 83, pp. 25-33
*/
vector<pair<int, int>>* adj_direct(matrix X, double* Y, int N, int p, vector<int>& ord, double*& Ynew )
{
	vector<pair<int, int>>* adj= new vector<pair<int, int>>;
	adj->reserve(100);
	bool isP;
	bool isME;
	PredList list(N);
	vector<int> nP(N);

	for (int i=1; i<N; i++) {
		list.clean();
		for (int j=i-1; j>=0; j--) {
			isP=isPredD(X, p, j, i);
			nP[i]+=isP;

			if(!isP) isME=false;
			else {
				isME=!(list.find(j,X,p));
			}

			if(isP && isME )  {
				adj->push_back(std::make_pair(j,i));
				list.addElem(j);
			}
		}
	}
	ord.resize(N);

	vector<int> revord(N);

	sortAdj(adj, nP, N, ord, revord);

	Ynew=new double[N];
	for(int i=0; i<N;i++) Ynew[i]=Y[ord[i]];

	return(adj);
};


double getnextcol(std::stringstream& lineStream) {
	std::string  cell;
	std::getline(lineStream,cell,',');
	return(atof(cell.c_str()));
}

void upload_data(char* filename, matrix& X, double*& Y, int N, int p){
	X=new double*[p];
	Y=new double[N];

	for(int i=0; i<p; i++) X[i]=new double[N];

	
	std::ifstream  data(filename);

	std::string line;
	std::getline(data, line); //labels;

	int j=0;
    while (std::getline(data,line))
    {
        std::stringstream  lineS(line);
		for(int i=0;i<p;i++) {
			X[i][j]=getnextcol(lineS);
		}
		Y[j]=getnextcol(lineS);
		j++;
    }
};