#include<vector>
#include<map>

using std::vector;
using std::pair;

class Node{
public:
	int index;
	Node* next;
	Node* last;
	Node(int ind){
		index=ind;
		next=nullptr;
		last=this;
	}
	Node(){
		index=0;
		next=nullptr;
		last=this;

	}
	void join(Node* n){
		last->next=n;
		last=n->last;
		n->last=nullptr;
	}
};


class Block {
public:
	Node* n;
	int* pred;
	int npred;
	int index;
	int currP;
	int currS;
	double Y;
	double w;
	Block(){
		currP=0;
		currS=0;
		pred=nullptr;
		npred=0;

	}
	void addPred(int i){
		pred[currP]=i;
		currP++;
	}
	void joinBlock(Block *b, bool*& unify, int*&whichblock, int N){
		Y=(Y*w+b->Y*b->w)/(w+b->w);
		w=w+b->w;
		n->join(b->n);

		for(int i=0; i<N; i++) unify[i]=0;
		for(int i=0; i<npred; i++) unify[whichblock[pred[i]]]=1;
		for(int i=0; i<b->npred; i++) unify[whichblock[b->pred[i]]]=1;

		delete[] pred;
		if(b->npred>0) delete[] b->pred;
		unify[index]=0;

		npred=0;
		for(int i=0;i<N; i++) npred=npred+unify[i];
		
		b->index=-1;
		b->n=nullptr;
		pred=new int[npred];
		
		int counter=0;
		for(int i=0; i<N; i++){
			if(unify[i]) {
				pred[counter]=i;
				counter++;
			}
		}

	}
	void updateResponse(double*& resp) {
		Node* curr=n;
		while(curr!=nullptr){
			resp[curr->index]=Y;
			curr=curr->next;
		}
	}
	void updateWhich(int*& which, int i){
		Node* curr=n;
		while(curr!=nullptr){
			which[curr->index]=i;
			curr=curr->next;
		}
	}

	~Block(){
		if(index!=-1) {
			delete [] pred;
			Node* curr=n;
			Node* curr0=n;
			while(curr!=nullptr) {
				curr=curr->next;
				delete curr0;
				curr0=curr;
			}
		}

	}


};

void adj2Block(vector<pair<int, int>>& adj, double* y, int N, Block*& list) {
	list=new Block [N];
	int* npred=new int [N];
	pair<int,int> e;
	int k,l;

	for(int i=0; i<N; i++) {
		npred[i]=0;
	}

	for(int i=0; i<adj.size();i++) {
		e=adj[i];
		k=e.first;
		l=e.second;
		npred[l]++;
	}
	
	for(int i=0; i<N; i++) {
		list[i].index=i;
		list[i].n=new Node(i);
		list[i].Y=y[i];
		list[i].w=1;
		list[i].pred=new int[npred[i]];
		list[i].npred=npred[i];
	}

	for(int i=0; i<adj.size();i++) {
		e=adj[i];
		k=e.first;
		l=e.second;
		list[l].addPred(k);
	}
};

int findMax(Block*& bl, int* ind, int* whichblock, int l, int N) {
	double m=bl[whichblock[ind[0]]].Y;
	int res=whichblock[ind[0]];
	int ii;
	for(int i=0; i<l; i++){
		ii=whichblock[ind[i]];
		if(m<bl[ii].Y) {
			m=bl[ii].Y;
			res=ii;
		}
	}
	return(res);
}

/* Function computes approximate monotonic regression of y based on adjacency matrix adj=[N x p]. Output:
	- Fitted value obtained by the algorithm


	Code written by O. Sysoev

     Reference: O. Burdakov, O. Sysoev, A. Grimvall and M. Hussian. 
                "An O(n2) algorithm for isotonic regression."
                 In: G. Di Pillo and M. Roma (Eds) Large-Scale Nonlinear Optimization.
                 Series: Nonconvex Optimization and Its Applications,
                 Springer-Verlag, (2006) 83, pp. 25-33
*/
double*  GPAV(vector<pair<int, int>>& adj, int N, double* y) {
	Block* block;
	adj2Block(adj,y,N,block);
	bool* unify= new bool[N];
	int* whichblock= new int[N];

	for(int i=0; i<N; i++) whichblock[i]=i;

	int mi;

	for(int i=1; i<N; i++){
		mi=1;
		while(mi>-1) {
			if (block[i].npred==0) {
				mi=-1;
				continue;
			}
			mi=findMax(block, block[i].pred,whichblock,block[i].npred,N);
			if(block[i].Y<block[mi].Y){
				block[mi].updateWhich(whichblock,i);
				block[i].joinBlock(&block[mi], unify, whichblock, N);
			} else {
				mi=-1;
			}

		}

	}

	double* Yfit=new double[N];
	for (int i=0;i<N; i++) 
		if (block[i].index>-1) {
			block[i].updateResponse(Yfit);
		}

	delete[] block;
	delete[] unify;
	delete[] whichblock;
	return(Yfit);
}


